<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<!-- 
IGAC proyecto SNC
@author: juan.agudelo

    Componente que permite la visualización de la galeria de imagenes y 
    folleto asociados a una oferta inmobiliaria
    
     parámetros de entrada:
     -managedBeanAtt: 	         Nombre del ManagedBean del que se obtendran los parametros 
     -selectedFotografiaListAtt: Objeto del tipo lista de fotografías al que estaran asociadas
                                 las fotografías
     -selectedFotografiaAtt:     Objeto del tipo fotografía al que estaran asociados
                                 los datos
     -compositeIdAtt:			 Id del composite
     -compositeWVAtt			 Identificardor del WidgetVar de la ventana modal en la que va 
                                 incluido el componente
     -archivoUploadAtt:          Método de carga de archivos
     
-->
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:f="http://java.sun.com/jsf/core"
      xmlns:ui="http://java.sun.com/jsf/facelets"
      xmlns:p="http://primefaces.org/ui"
      xmlns:composite="http://java.sun.com/jsf/composite">

    <composite:interface>

        <composite:attribute name="managedBeanAtt" required="true" />
        <composite:attribute name="selectedFotografiaListAtt" required="true" />
        <composite:attribute name="selectedFotografiaAtt" required="false" />
        <composite:attribute name="banderaPanelEdicionFotosAtt"
                             required="false" />
        <composite:attribute name="banderaCargaAtt" required="true" />
        <composite:attribute name="compositeWVAtt" required="true" />
        <composite:attribute name="compositeIdAtt" required="true" />

        <ui:remove>
            <composite:attribute name="seleccionarTodasLasFotosAtt"
                                 required=" false" method-signature="void seleccionarTodasLasFotos()" />
            <composite:attribute name="archivoUploadAtt" required="false"
                                 method-signature="void archivoUpload(org.primefaces.event.FileUploadEvent)" />
        </ui:remove>

    </composite:interface>

    <composite:implementation>
        <h:panelGrid id="compfotosId" columns="1">

            <h:panelGrid columns="1">

                <h:form id="cargarfotosForm" enctype="multipart/form-data"
                        rendered="#{cc.attrs.banderaCargaAtt}" prependId="false">

                    <p:messages id="msgs" showDetail="false" globalOnly="false" />
                    <p:fieldset legend="Gestor de fotografías">

                        <h:panelGrid columns="6" cellspacing="7">

                            <h:outputLabel value="Tipo fotografía"
                                           styleClass="outputLabelStyle" />

                            <h:selectOneMenu id="tipoFoto" label="Tipo de fotografía"
                                             value="#{cc.attrs.selectedFotografiaAtt.tipoFoto}">
                                <f:selectItems value="#{general.ofertaFotoTipoFotoV}" />
                                <p:ajax process="@this" />
                            </h:selectOneMenu>

                            <h:outputLabel value="Descripción:" for="descripcion"
                                           styleClass="outputLabelStyle" />

                            <h:inputTextarea id="descripcion"
                                             value="#{cc.attrs.selectedFotografiaAtt.descripcion}" cols="30"
                                             rows="2">
                                <p:ajax process="@this" />
                            </h:inputTextarea>

                            <p:spacer height="13" width="7" />
                            <p:outputPanel layout="block">
                                <p:fileUpload id="fu" label="Cargar y guardar fotografía"
                                              fileUploadListener="#{prueba.archivoUpload}"
                                              dragDropSupport="true" widgetVar="uploader" mode="advanced"
                                              auto="true" sizeLimit="#{general.maximoTamanoAdjuntos}"
                                              allowTypes="/(\.|\/)(tif|dwg|png|jpg|jpeg|gif|bmp)$/"
                                              update=":#{cc.attrs.compositeIdAtt}:galleriaForm,msgs,
                                              :#{cc.attrs.compositeIdAtt}:cargarfotosForm:tipoFoto,
                                              :#{cc.attrs.compositeIdAtt}:cargarfotosForm:descripcion,
                                              :#{cc.attrs.compositeIdAtt}:galleriaForm"
                                              onstart="statusDialog2.show();"
                                              oncomplete="statusDialog2.hide();" />
                            </p:outputPanel>

                        </h:panelGrid>

                    </p:fieldset>
                </h:form>

                <h:form id="galleriaForm" prependId="false">

                    <h:panelGrid columns="2">
                        <p:spacer height="0" width="50" />
                        <p:galleria effect="slide" frameHeight="80" frameWidth="80"
                                    value="#{cc.attrs.selectedFotografiaListAtt}"
                                    rendered="#{not empty cc.attrs.selectedFotografiaListAtt}"
                                    var="foto" effectSpeed="1000" transitionInterval="0">
                            <h:panelGrid columns="2">
                                <p:graphicImage
                                    value=""
                                    title="fixme"  />

                            </h:panelGrid>
                        </p:galleria>
                        <h:outputText
                            value="No hay fotografías relacionadas con esta oferta"
                            styleClass="outputTextStyle"
                            rendered="#{empty cc.attrs.selectedFotografiaListAtt and !cc.attrs.banderaCargaAtt}" />
                    </h:panelGrid>

                    <p:spacer width="0" height="13" />

                    <h:panelGrid columns="2">
                        <p:spacer width="35" height="7" />
                        <p:commandLink value="Eliminar fotografías"
                                       styleClass="commandLinkStyle"
                                       update=":#{cc.attrs.compositeIdAtt}:galleriaForm:fotosEdId,:#{cc.attrs.compositeIdAtt}:galleriaForm"
                                       immediate="true"
                                       rendered="#{(not empty cc.attrs.selectedFotografiaListAtt and cc.attrs.managedBeanAtt.banderaFotografiasCargadas) and cc.attrs.banderaCargaAtt}">
                            <f:setPropertyActionListener value="true"
                                                         target="#{cc.attrs.banderaPanelEdicionFotosAtt}" />
                        </p:commandLink>
                    </h:panelGrid>

                    <h:panelGrid columns="1" width="100%">

                        <p:fieldset legend="Edición de fotografias" id="fotosEdId"
                                    rendered="#{cc.attrs.banderaPanelEdicionFotosAtt and not empty cc.attrs.selectedFotografiaListAtt}">
                            <h:panelGrid columns="4" cellspacing="7" width="100%">

                                <ui:repeat var="fotosE"
                                           value="#{cc.attrs.selectedFotografiaListAtt}">

                                    <h:selectBooleanCheckbox
                                        value="#{fotosE.fotografiaSeleccionada}" />
                                    <p:graphicImage width="70" height="70"
                                                    value="#{cc.attrs.managedBeanAtt.directorioTemporal}#{fotosE.archivoFotografia}" />
                                    <p:spacer height="0" width="7" />
                                </ui:repeat>
                            </h:panelGrid>

                            <p:spacer height="13" width="0" />
                            <p:outputPanel layout="block" style="text-align:right;">
                                <p:commandButton title="Eliminar todas las fotos" ajax="true"
                                                 value="Eliminar todas las fotos" icon="ui-icon-trash"
                                                 update=":#{cc.attrs.compositeIdAtt}:galleriaForm:fotosEdId,
                                                 :#{cc.attrs.compositeIdAtt}:galleriaForm"
                                                 action="#{cc.attrs.managedBeanAtt.eliminarFotosAll}" />

                                <p:spacer width="13" height="13" />
                                <p:commandButton title="Eliminar fotos seleccionadas" ajax="true"
                                                 value="Eliminar fotos seleccionadas" icon="ui-icon-trash"
                                                 update=":#{cc.attrs.compositeIdAtt}:galleriaForm:fotosEdId,
                                                 :#{cc.attrs.compositeIdAtt}:galleriaForm"
                                                 action="#{cc.attrs.managedBeanAtt.eliminarFotos}" />
                                <p:spacer width="0" height="13" />

                            </p:outputPanel>
                            <p:spacer width="0" height="13" />
                        </p:fieldset>

                        <p:spacer width="20" height="0" />
                        <p:outputPanel layout="block" style="text-align:right;">
                            <p:commandButton value="Guardar"
                                             rendered="#{(not empty cc.attrs.selectedFotografiaListAtt and cc.attrs.managedBeanAtt.banderaFotografiasCargadas) and cc.attrs.banderaCargaAtt}"
                                             action="#{cc.attrs.managedBeanAtt.guardarFotos}"
                                             oncomplete="#{cc.attrs.compositeWVAtt}.hide()" />
                            <p:spacer width="30" height="0" />

                        </p:outputPanel>
                    </h:panelGrid>

                </h:form>
            </h:panelGrid>
        </h:panelGrid>
    </composite:implementation>
</html>